<?php
ob_start();
class techno_wc_bulk_price_update_lic_class
{    
    public $techno_lic;
    public $server;
    public $api_key;
    private $wp_option  = 'techno_wc_bulk_price_update_wp_plugin';
    public $err;
    public function __construct($techno_lic=false , $server , $api_key)
    {
        if($this->is_techno_wc_bulk_price_update_act_lic())
        {
            $techno_lic_tc = unserialize(base64_decode(get_option($this->wp_option)));
            $this->techno_lic = $techno_lic_tc['l'];
        }
        else
        {
            $this->techno_lic = $techno_lic;
        }
        $this->server  = $server;
        $this->api_key = $api_key;
    }
    public function is_techno_wc_bulk_price_update_act_lic()
    {
        $techno_lic = get_option($this->wp_option);
        if(!empty( $techno_lic ))
        {
            $var_res=unserialize(base64_decode($techno_lic));
            if( @$var_res['d'] == strtotime(date('d-m-Y')))
            {
                return true;               
            }
            else
            {
                return $this->techno_wc_bulk_price_update_chack_key_status();
            }
        }
        else
        {     
            return false;
        }
    }    
    public function techno_wc_bulk_price_update_deactive()
    {
        $lic_data = unserialize(base64_decode(get_option($this->wp_option)));
        $deact_url = TECHNO_LICENSE_SERVER_URL . '/?secret_key=' . TECHNO_SPECIAL_SECRET_KEY . '&slm_action=slm_deactivate&license_key=' . $lic_data['l'] . '&registered_domain=' . get_site_url();
        $response = wp_remote_get($deact_url, array('timeout' => 20, 'sslverify' => false));
        if(is_array($response))
        {
            $json = $response['body']; 
            $json = preg_replace('/[\x00-\x1F\x80-\xFF]/', '', utf8_encode($json));
            $license_data = json_decode($json);
            if($license_data->result == 'success')
            {
                delete_option($this->wp_option);
                return true;
            }
            else
            {
                delete_option($this->wp_option);
                return false;
            }
        }
    }
    public function techno_wc_bulk_price_update_chack_key_status()
    {
        $techno_lic2 = unserialize(base64_decode(get_option($this->wp_option)));
        $techno_ch_url = $this->server . '/?secret_key=' . $this->api_key . '&slm_action=slm_activate&license_key=' . $techno_lic2['l']. '&registered_domain=' . get_site_url().'&item_reference=My_techno_wc_bulk_price_update_wp_plugin_01';
        $tc_res_lic_st = wp_remote_get($techno_ch_url, array('timeout' => 20, 'sslverify' => false));
        if(is_array($tc_res_lic_st))
        {
            $tc_bd_js_dt = $tc_res_lic_st['body'];
            $tc_bd_js_dt = preg_replace('/[\x00-\x1F\x80-\xFF]/', '', utf8_encode($tc_bd_js_dt));
            $tc_res_lic_dt = json_decode($tc_bd_js_dt);
            if((isset($tc_res_lic_dt->error_code)) && ($tc_res_lic_dt->error_code == 40 || $tc_res_lic_dt->error_code == 110 ))
            {           
                $mkey = base64_encode(serialize(array('l' => $techno_lic2['l'] , 'd' =>strtotime(date('d-m-Y')) , 's' => $tc_res_lic_dt->error_code )));
                update_option( $this->wp_option, $mkey );
                return true;            
            }
            else
            {
                $this->err = $tc_res_lic_dt->message;
                return false;
            }
        }
    }
    public function techno_wc_bulk_price_update_lic_data($status)
    {
        $tc_dc_mk = base64_encode(serialize(array('l' => $this->techno_lic, 'd' =>strtotime(date('d-m-Y')) , 's' => $status )));
        update_option( $this->wp_option, $tc_dc_mk );
    }
    public function techno_wc_bulk_price_update_act_call()
    {
        $tc_ur_lk = $this->server . '/?secret_key=' . $this->api_key . '&slm_action=slm_activate&license_key=' . $this->techno_lic . '&registered_domain=' . get_site_url().'&item_reference=My_techno_wc_bulk_price_update_wp_plugin_01';
        $tc_ac_res_dt = wp_remote_get($tc_ur_lk, array('timeout' => 20, 'sslverify' => false));
        if(is_array($tc_ac_res_dt))
        {
            $tc_ac_res_dt_js = $tc_ac_res_dt['body']; // use the content
            $tc_ac_res_dt_js = preg_replace('/[\x00-\x1F\x80-\xFF]/', '', utf8_encode($tc_ac_res_dt_js));
            $tc_wc_bulk_price_update_res_data = json_decode($tc_ac_res_dt_js);
            if($tc_wc_bulk_price_update_res_data->result == 'success' || $tc_wc_bulk_price_update_res_data->error_code == 40 || $tc_wc_bulk_price_update_res_data->error_code ==110)
            {
                $status='';
                if(isset($tc_wc_bulk_price_update_res_data->error_code)){
                   $status = $tc_wc_bulk_price_update_res_data->error_code;
                }
                $this->techno_wc_bulk_price_update_lic_data($status);
                return true;
            }
            else
            {
                $this->err = $tc_wc_bulk_price_update_res_data->message;
                return false;
            }
        }
    }
}